// $Id: install-pack.js,v 1.13 2002/05/08 12:00:05 mal Exp $

// Update by matsuba
//   Localize alert messages in alert() function. 


// this function verifies disk space in kilobytes
function verifyDiskSpace(dirPath, spaceRequired)
{
    var spaceAvailable;
    spaceAvailable = fileGetDiskSpaceAvailable(dirPath);
    spaceAvailable = parseInt(spaceAvailable / 1024);

    if (spaceAvailable < spaceRequired)
    {
        logComment("Insufficient disk space: " + dirPath);
        logComment("  required : " + spaceRequired + " K");
        logComment("  available: " + spaceAvailable + " K");
        return (false);
    }
    return (true);
}

// OS type detection
function getPlatform()
{
    var platformStr;
    var platformNode;

    if ('platform' in Install)
    {
        platformStr = new String(Install.platform);
        logComment("platformStr: " + platformStr);

        if (!platformStr.search(/^Macintosh/))
            platformNode = 'mac';
        else if (!platformStr.search(/^Win/))
            platformNode = 'win';
        else
            platformNode = 'unix';
    }
    else
    {
        var fOSMac = getFolder("Mac System");
        var fOSWin = getFolder("Win System");

        logComment("fOSMac: " + fOSMac);
        logComment("fOSWin: " + fOSWin);

        if (fOSMac != null)
            platformNode = 'mac';
        else if (fOSWin != null)
            platformNode = 'win';
        else
            platformNode = 'unix';
    }

    return platformNode;
}

// main
var srDest = 1320;
var err;
var fProgram;
var platformNode;
var fSearchPlugins; // searchplugins directory variable (mal@mozilla.gr.jp)

platformNode = getPlatform();
logComment("initInstall: platformNode=" + platformNode);
// end - OS type detection

// ----LOCALIZATION NOTE: translate only these ------
var prettyName = "Japanese";
var langcode = "ja";
var regioncode = "JP";
var chromeNode = langcode + "-" + regioncode;
// --- END LOCALIZABLE RESOURCES ---
var regName = "locales/mozilla/" + chromeNode;
var chromeName = chromeNode + ".jar";
var regionFile = regioncode + ".jar";
var platformName = langcode + "-" + platformNode + ".jar";
var localeName = "locale/" + chromeNode + "/";
var regionName = "locale/" + regioncode + "/";
// var messages;                                    --- Comment out by matsuba

err    = initInstall(prettyName, regName, "1.x.x");
logComment("initInstall: " + err);

fProgram = getFolder("Program");
logComment("fProgram: " + fProgram);

// messages = loadResources('install.properties');  --- Comment out by matsuba

// searchplugins directory detection (mal@mozilla.gr.jp)
if (platformNode == 'mac')
{
    fSearchPlugins = getFolder("Program", "Search Plugins");
}
else
{
    fSearchPlugins = getFolder("Program", "searchplugins");
}

logComment("fSearchPlugins: " + fSearchPlugins);

if (verifyDiskSpace(fProgram, srDest))
{
    err = addDirectory("", "sp", fSearchPlugins, "");
    logComment("addDirectory() searchplugins returned: " + err);

    if (platformNode != 'mac')
    {
        err = addDirectory("", "sp_nomac", fSearchPlugins, "");
        logComment("addDirectory() else mac searchplugins returned: " + err);
    }

    var chromeType = LOCALE ;
    err = addDirectory("", "bin", fProgram, "");
    logComment("addDirectory() returned: " + err);

    // if (err != SUCCESS)
    // {

    //     // couldn't install globally, try installing to the profile
    //     logComment("addDirectory() to " + fProgram + "failed!");

    //     resetError();
    //     chromeType |= PROFILE_CHROME;
    //     fProgram = getFolder("Profile");
    //     logComment("try installing to the user profile:" + fProgram);
    //     err = addDirectory("", "bin/chrome", fProgram, "chrome");
    // }

    setPackageFolder(fProgram);

    // check return value
    if (err == SUCCESS)
    {
        // register chrome
        var cf = getFolder(fProgram, "chrome/" + chromeName);
        var pf = getFolder(fProgram, "chrome/" + platformName);
        var rf = getFolder(fProgram, "chrome/" + regionFile);

        registerChrome(chromeType, cf, localeName + "global/");
        registerChrome(chromeType, cf, localeName + "communicator/");

        registerChrome(chromeType, cf, localeName + "messenger/");
        registerChrome(chromeType, cf, localeName + "editor/");
        registerChrome(chromeType, cf, localeName + "navigator/");
        registerChrome(chromeType, cf, localeName + "necko/");
        registerChrome(chromeType, cf, localeName + "p3p/");
        registerChrome(chromeType, cf, localeName + "cookie/");
        registerChrome(chromeType, cf, localeName + "wallet/");
        registerChrome(chromeType, cf, localeName + "pipnss/");
        registerChrome(chromeType, cf, localeName + "pippki/");
        registerChrome(chromeType, cf, localeName + "content-packs/");
        registerChrome(chromeType, cf, localeName + "help/");
        registerChrome(chromeType, cf, localeName + "mozldap/");
//      registerChrome(chromeType, cf, localeName + "forms/");
        registerChrome(chromeType, cf, localeName + "autoconfig/");
        registerChrome(chromeType, cf, localeName + "messenger-smime/");
        registerChrome(chromeType, cf, localeName + "messenger-mdn/");
        registerChrome(chromeType, cf, localeName + "chatzilla/");
        registerChrome(chromeType, cf, localeName + "venkman/");
        registerChrome(chromeType, cf, localeName + "inspector/");

        registerChrome(chromeType, pf, localeName + "global-platform/");
        registerChrome(chromeType, pf, localeName + "communicator-platform/");
        registerChrome(chromeType, pf, localeName + "navigator-platform/");

        if (platformNode == "win")
            registerChrome(chromeType, pf, localeName + "messenger-mapi/");

        registerChrome(chromeType, rf, regionName + "global-region/");
        registerChrome(chromeType, rf, regionName + "communicator-region/");
        registerChrome(chromeType, rf, regionName + "editor-region/");
        registerChrome(chromeType, rf, regionName + "messenger-region/");
        registerChrome(chromeType, rf, regionName + "navigator-region/");

        err = performInstall();
        logComment("performInstall() returned: " + err);

        if (err == SUCCESS || err == 999)
        {
            alert("\u30a4\u30f3\u30b9\u30c8\u30fc\u30eb\u306f\u7d42\u4e86\u3057\u307e\u3057\u305f\u3002\n\n\u65e5\u672c\u8a9e\u3078\u306e\u5207\u66ff\u3048\u306f\u3001\u6b21\u306e\u3044\u3065\u308c\u304b\u3092\u5b9f\u65bd\u3057\u3066\u304f\u3060\u3055\u3044\u3002\n\n\n \u25a0 \u65b9\u6cd51(\u753b\u9762\u64cd\u4f5c\u306e\u307f): \n1. Edit > Preferences (Category: Appearance > Languages/Content)) \u3092\u958b\u304d\u307e\u3059\u3002\n 2. Japanese(Japan) \u3084 JP Region \u3092\u9078\u629e\u3057\u3066 [OK] \u30dc\u30bf\u30f3\u3092\u62bc\u4e0b\u3057\u307e\u3059\u3002\n 3. Mozilla \u3092\u518d\u8d77\u52d5\u3057\u307e\u3059\u3002\n\n\n \u25a0 \u65b9\u6cd52(\u30b3\u30de\u30f3\u30c9\u30e9\u30a4\u30f3): \n1. Mozilla \u3092\u7d42\u4e86\u3057\u307e\u3059\u3002\n2. Mozilla \u3092 -UILocale ja-JP -contentLocale JP \u4ed8\u304d\u3067\u518d\u8d77\u52d5\u3057\u307e\u3059\u3002(\u4e00\u5ea6\u306e\u307f)\n(\u203b)\u30aa\u30d7\u30b7\u30e7\u30f3\u6307\u5b9a\u306e\u8d77\u52d5\u306f\u4e00\u5ea6\u884c\u3048\u3070\u3001\u6b21\u56de\u304b\u3089\u306f\u5fc5\u8981\u3042\u308a\u307e\u305b\u3093\u3002");
        }
        else
        {
            alert("\u30a4\u30f3\u30b9\u30c8\u30fc\u30eb\u306f\u5931\u6557\u3057\u307e\u3057\u305f\u3002\u30a8\u30e9\u30fc\u30b3\u30fc\u30c9\uff1a" + err);
        }

    }
    else
    {
        cancelInstall(err);
        logComment("cancelInstall due to error: " + err);

        if (err == -202)
        {
            alert("\u30a4\u30f3\u30b9\u30c8\u30fc\u30eb\u306f " + err + " \u306b\u3088\u308a\u30ad\u30e3\u30f3\u30bb\u30eb\u3055\u308c\u307e\u3057\u305f\u3002\n" +
                  "\u3042\u306a\u305f\u306f Mozilla 'chrome' \u30c7\u30a3\u30ec\u30af\u30c8\u30ea\u306b\u5bfe\u3059\u308b\u66f8\u304d\u8fbc\u307f\u6a29\u9650\u3092\u3082\u3063\u3066\u3044\u306a\u3044\u3088\u3046\u3067\u3059\u3002\nroot \u307e\u305f\u306f\u3001\u30b7\u30b9\u30c6\u30e0\u7ba1\u7406\u8005\u3068\u3057\u3066\u30a4\u30f3\u30b9\u30c8\u30fc\u30eb\u3092\u3057\u3066\u304f\u3060\u3055\u3044\u3002");
        }
        else
        {
            alert("\u30a4\u30f3\u30b9\u30c8\u30fc\u30eb\u306f\u30ad\u30e3\u30f3\u30bb\u30eb\u3055\u308c\u307e\u3057\u305f\u3002\u30a8\u30e9\u30fc\u30b3\u30fc\u30c9\uff1a" + err);
        }
    }
}
else
    cancelInstall(INSUFFICIENT_DISK_SPACE);

// end main
